!========================================================================
!>
!! @author
!! David Car, david.car7@gmail.com
!!
!! @brief
!!
!! @details
!!
!! @todo
!!
!! @par Copyright (c) 2009,2010,2011 David Car, david.car7\@gmail.com
!! @par GNU General Public License, version 2 (GPLv2)
!! This program is free software; you can redistribute it and/or modify it under
!! the terms of the GNU General Public License as published by the Free Software
!! Foundation; either version 2 of the License, or (at your option) any later
!! version.
!! @par
!! This program is distributed in the hope that it will be useful, but WITHOUT
!! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
!! FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
!! @par
!! You should have received a copy of the GNU General Public License along with
!! this program; if not, write to the Free Software Foundation, Inc., 59 Temple
!! Place, Suite 330, Boston, MA 02111-1307 USA
!<
!========================================================================
module UnitServer
  implicit none

  public :: getUnit, freeUnit
  private :: minUnit, maxUnit, units

  save
  integer, parameter :: minUnit=11, maxUnit=100
  logical :: units(minUnit:maxUnit) = .true.

contains
  function getUnit()  result(u)
    !................................................................................
    ! Linear search over units array for available unit number
    !................................................................................
    integer :: u
    
    u = minUnit
    do while (.not. units(u) .and. u<=maxUnit)
       u = u+1
    end do
    units(u) = .false.
  end function getUnit

  subroutine freeUnit(u)
    !................................................................................
    ! Free a unit number and reset to -1
    !................................................................................
    integer, intent(inout) :: u
    
    if (u <= maxUnit .and. u >= minUnit) then
       units(u) = .true.
       u = -1
    endif
  end subroutine freeUnit

end module UnitServer
