#ifndef PYF95_UNITTEST_UNIT_MACROS_H
#define PYF95_UNITTEST_UNIT_MACROS_H

!=======================================================================
! CONDITIONALS
!=======================================================================
!... Positive conditionals .............................................
#define unit_assert_(Flag, Cond, Mess)  Flag = unittest_assert(this, Cond, msg=Mess, file=__FILE__, line=__LINE__)
#define unit_assertTrue(Flag, Cond, Mess)  Flag = unittest_assert_true(this, Cond, msg=Mess, file=__FILE__, line=__LINE__)
#define unit_failUnless(Flag, Cond, Mess)  Flag = unittest_assert_true(this, Cond, msg=Mess, file=__FILE__, line=__LINE__)

!... Equality conditionals .............................................
#define unit_assertEqual(First,Second,Mess)
#define unit_failUnlessEqual(First,Second,Mess)

!... Inequality conditionals ...........................................
#define unit_assertNotEqual(First,Second,Mess)
#define unit_failIfEqual(First,Second,Mess)

!... Near equality conditionals ........................................
#define unit_assertAlmostEqual(First,Second,Tol,Mess)
#define unit_failUnlessAlmostEqual(First,Second,Tol,Mess)

!... Mostly inequality conditionals ....................................
#define unit_assertNotAlmostEqual(First,Second,Mess)
#define unit_failIfAlmostEqual(First,Second,Mess)

!... Negative conditionals .............................................
#define unit_assertFalse(Flag, Cond, Mess)  Flag = unittest_assert_false(this, Cond, msg=Mess, file=__FILE__, line=__LINE__)
#define unit_failIf(Flag, Cond, Mess)  Flag = unittest_assert_false(this, Cond, msg=Mess, file=__FILE__, line=__LINE__)

!... Negative ..........................................................
#define unit_fail(Flag, Mess) Flag = unittest_assert_false(this, .true., msg=Mess, file=__FILE__, line=__LINE__)

!=======================================================================
! UTILITIES
!=======================================================================
#define unit_pushMessage(Mess) call unittest_push_message(this, Mess, file=__FILE__, line=__LINE__)
#define unit_failReturn(Cond) if (.not. Cond) return

#endif
