#include "PyF95_macros.inc"
    !................................................................................
    function decRef( msg )  result( b )
     !................................................................................
     !
     ! Decrement the reference count on the object and return a boolean on
     ! whether the refCount is 0.  .true. means refCount ==0, .false. means
     ! otherwise.
     !
     !................................................................................
     implicit none
     logical :: b
     character(len=*), optional :: msg

#ifdef __POLYTYPE
     select type( t => this % PYF95_REF_NAME )
     type is( __POLYTYPE )
        XDECREF(this)
     end select
#else
     XDECREF(this)
#endif

     b = (XREFCNT(this) == 0)
     if (XREFCNT(this) < 0) then
        if ( present( msg ) ) then
          print *,'Reference count less than zero in '//TRIM(msg)//'!'
          print *,'Someone did something very nasty...'
          stop
        else
          print *,'Reference count less than zero!'
          print *,'Someone did something very nasty...'
          stop
       endif
     end if

#ifdef VERBOSE
      if (present(msg)) then
        print *,'The '//msg//' refCount is now: ', this % PYF95_REF_NAME % refCount
      endif
#endif

    end function decRef
