# include "PyF95_macros.inc"
  subroutine setup(msg)
    implicit none
    character (len=*) :: msg

#ifdef __POLYTYPE
    !==========================================================================
    ! If the pointer is associated, check if it is one of __POLYTYPE
    ! type.  If it is, then the constructor is not being called from a
    ! subclass.  Therefore, it can be deleted and reinitialized.  If it
    ! is not associated, then just allocate a new __POLYTYPE pointer.
    !==========================================================================
    if ( associated( this % PYF95_REF_NAME) ) then
       select type( data => this % PYF95_REF_NAME)
       type is ( __POLYTYPE )
#ifdef __TYPE_BOUND
          derr = this % delete()
#else
          derr = delete( this )
#endif
          if ( catch( derr ) ) then
             err % msg = 'Error dereferencing '//msg//'.  Error was: '//derr%msg
             err % error = 1
             return
          endif
          allocate( __POLYTYPE :: this % PYF95_REF_NAME, stat=err%error)
          this % PYF95_REF_NAME % refCount = 1
       end select
    else
       allocate( __POLYTYPE :: this % PYF95_REF_NAME, stat=err%error)
       this % PYF95_REF_NAME % refCount = 1
    endif
#else

#ifdef __TYPE_BOUND
    derr = this % delete()
#else
    derr = delete( this )
#endif
    if ( catch( derr ) ) then
       err % msg = 'Error dereferencing '//msg//'.  Error was: '//derr%msg
       err % error = 1
       return
    endif
#ifndef __IFORT_BUG_FIX__
    allocate( this % PYF95_REF_NAME, stat=err%error)
    this % PYF95_REF_NAME % refCount = 1
#endif
#endif

  end subroutine setup

    
