!................................................................................
#ifndef PYF95_MACROS_H
#define PYF95_MACROS_H

#ifndef PYF95_REF_NAME
#define PYF95_REF_NAME shared
#endif

#define INITIALIZE(msg) call setup(msg); if (catch(err)) return; allocate(this% PYF95_REF_NAME, stat=err%error); this % PYF95_REF_NAME % refCount = 1
#define NULL_RETURN(shared) if (.not. associated(shared)) return
#define NULL_STOP(shared) if (.not. associated(shared)) stop
#define XREFCNT(arg) arg% PYF95_REF_NAME % refCount
#define XDECREF(arg) XREFCNT(arg) = XREFCNT(arg) - 1
#define XINCREF(arg) XREFCNT(arg) = XREFCNT(arg) + 1
#define NULL_SET_TYPE_BOUND(this, other)  \
  if (.not. associated(other% PYF95_REF_NAME)) then; \
    lerr = catch(this % delete(), .true.); \
    this% PYF95_REF_NAME => null(); \
    return; \
  endif
#define NULL_SET(this, other)  \
  if (.not. associated(other% PYF95_REF_NAME)) then; \
    lerr = catch(delete(this), .true.); \
    this% PYF95_REF_NAME => null(); \
    return; \
  endif
#endif

#define ERROR_RETURN( arg, err ) err = arg; if ( catch( err ) ) return
#define ERROR_EXIT( arg, err ) err = arg; if ( catch( err ) ) exit
#define SIZE_OF( element ) SIZE( TRANSFER( element, ['a'] ) )

!................................................................................
#ifndef PYF95_UNITTEST_MACROS_H
#define PYF95_UNITTEST_MACROS_H

#define ASSERT_TRUE(a,res) if (.not. (a)) res = .false.
#define ASSERT_FALSE(a,res) if ((a)) res = .false.
#define FAIL_UNLESS_EQUAL(a,b,res) if ((a) /= (b)) res = .false.
#define FAIL_UNLESS_NOT_EQUAL(a,b,res) if ((a) /= (b)) res = .true.
#define FAIL_UNLESS_ALMOST_EQUAL(a,b,tol,res) if (ABS((a)-(b)) > tol) res = .false.
#define SET_MSG(b,a,msg) if (.not. (b)) a = msg

#define PUSH_MSG(b,msg) \
if (.not. (b)) then; \
  lerr = catch(init(ErrorString,msg)) ;\
  lerr = catch(push(messages, ErrorString)); \
  lerr = catch(delete(ErrorString)); \
endif

#define FAIL_RETURN(b) if (.not. (b)) return
#define PRINT_MSG(b, msg) if (.not. b) print "(4x, '-> ', A)", msg


#endif

!; print *, "Allocating "//TRIM(msg)
