#............................................................................
# Copyright (c) 2009,2010,2011 David Car, david.car7@gmail.com
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA 02111-1307 USA
#..........................................................................
__all__ = ['FortranBlockParser']

from blockit.parsers import BlockParser
from blockit.blocks import Block
from blockit.library import Library
import os

#..................
# Block parser
#..................
class FortranBlockParser( BlockParser ):
    def __init__( self, scanner=None ):
        super( FortranBlockParser, self ).__init__( scanner, 
                                                    ignoreChars='!', 
                                                    contChar='&')

    def parse( self, startBlock ):
        scanner = self._scanner
        if scanner is None:
            raise Exception("No scanner attribute!  Use setScanner().")
        
        #....................................................................
        # LineScanner throws EOFError exception when finished.  Wrap in
        # try/except to catch that.  Any other errors are errors in parsing
        # the file
        #....................................................................
        try:
            blk = startBlock

            # Run the internal recursive parser
            self._parse( blk )

        except EOFError:
            blk.ignoreDependencies( blk.getIgnoreDependencies() )
            blk.removeDependencies( blk.getIgnoreDependencies() )

        else:
            print "Error in parsing file %s"%(blk.name(),)

        return blk

    def __propScanner():
        doc = "Return the scanner"
        def fget( self ):
            return self._scanner
        return locals()

    scanner = property( **__propScanner() )
        

